uses crt, graph, vbxe, sysutils;

type	TBmpHeader = record
	bftype:word;
	bfsize:integer;
	bfreserv1:word;
	bfreserv2:word;
	bfoffbits:integer;

	bisize:integer;
	biwidth:integer;
	biheight:integer;
	biplanes:word;
	bibitcount:word;
	bicompress:integer;
	bisizeimage:integer;
	biXPelsPerMeter:integer;
	biYPelsPerMeter:integer;
	biClrUsed:integer;
	biClrImportant:integer;
	end;

var	fnam: TString;
	bmphead: TBmpHeader;
	xdl: TXDL;

	buf: array [0..255] of byte absolute $0400;


procedure SetPalette(var f: file; cnt: word);
var i: word;
begin

	SetRGBPalette(0);

	for i:=0 to cnt-1 do begin
		blockread(f, buf, 4);
		SetRGBPalette(buf[2], buf[1], buf[0]);
	end;

end;


procedure bits(var f:file; dst: cardinal);
var x, adr: word;
    w, h: word;
    a: cardinal;
    bnk, b, v, i: byte;

	procedure SetBankAdr;
	begin
		bnk:=a div $4000+$80;
		adr:=a mod $4000+$4000;

		SetVideoBank(bnk);

		x:=0;
	end;

begin

 blockread(f, bmphead, sizeof(bmphead));
 
 w:=bmphead.biwidth;
 h:=bmphead.biheight;
 b:=bmphead.bibitcount;

 if w mod 4<>0 then w:=(w shr 2) shl 2 + 4;

 xdl.ov_step := w;

 SetXDL(xdl);

 case b of
  4: SetPalette(f, 64);
  8: SetPalette(f, 256);
 end;

 a:=dst+w*h-w;

 SetBankAdr;

 while not eof(f) do begin
 
	case b of
	  4:  begin
		blockread(f, buf[128], 64);
		
		for i:=0 to 63 do begin
		  v:=buf[128+i];
		  buf[i shl 1]:=v shr 4;
		  buf[i shl 1+1]:=v and $0f;
		end;

	      end;
	
	  8: blockread(f, buf, 128);	
	
	end;
 
	for i:=0 to 127 do begin

	 poke(adr, buf[i]);

	 inc(adr);

	 if adr > $7fff then begin
		SetVideoBank(bnk+1);
		adr:=$4000;
	 end;

	 inc(x);
	 if x>w-1 then begin
		dec(a, w);

		SetBankAdr;
		
		if h=0 then begin SetVideoBank(0); exit end;

		dec(h);
	 end;
	
	end;
 end;

end;


procedure LoadVBMP(fn: TString; dst: cardinal);
var f: file;
begin

 if not FileExists(fn) then begin
   writeln('File not found');
   halt; 
 end;

 assign(f, fn); reset(f, 1);

 bits(f, dst);

 close(f);

end;


begin

 InitGraph(vbxe, 0, '');

 if GraphResult <> grOK then begin
  writeln('VBXE not detected');
  halt;
 end;

 write('Load BMP >');
 readln(fnam);

 GetXDL(xdl);

 LoadVBMP(fnam, VBXE_OVRADR);
 
 repeat until keypressed;
 
end.

